Pictogram Crowd in JavaScript

Using ApexCharts with JavaScript

This Pictogram Crowd example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Shared by the vanilla-js, React and Vue builds. Layout and mark are two
// INDEPENDENT choices, so the state is two fields and the update payload sets
// each from its own field; nothing here knows which combination is selected.
var pictoState = { layout: 'heart', mark: 'person' }

// The updateOptions payload for the current pair. An empty mark means "no
// glyph", which is just the ordinary dot the chart drew before pictograms
// existed - `shape` carries that, so `pictogram.mark` is left alone.
function pictoOptions() {
  return {
    plotOptions: {
      unit: {
        positions: pictoState.layout,
        shape: pictoState.mark ? 'pictogram' : 'circle',
        pictogram: { mark: pictoState.mark || undefined },
      },
    },
  }
}

function pictoPaint() {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.classList.toggle(
      'on',
      b.getAttribute('data-layout') === pictoState.layout,
    )
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.classList.toggle('on', b.getAttribute('data-mark') === pictoState.mark)
  })
}

// Wire both button rows to a live chart instance. Each format hands over its
// own instance; the behaviour is identical.
function pictoWire(chart) {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.layout = b.getAttribute('data-layout')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.mark = b.getAttribute('data-mark')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  pictoPaint()
}

var options = {
  series: [820, 410, 170],
  chart: {
    type: 'unit',
    id: 'pictoCrowd',
    height: 460,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: ['Weekday shifts', 'Weekend shifts', 'On call'],
  colors: ['#1D4E89', '#00A6A0', '#FF8A3D'],
  plotOptions: {
    unit: {
      layout: 'custom',
      positions: 'heart',
      // A glyph, not a dot. `mark` names one of the pictograms; the chart fits
      // it to the box the dot would have occupied, so switching between them
      // never re-flows the layout.
      shape: 'pictogram',
      pictogram: {
        mark: 'person',
      },
      // The same specific volunteer keeps their glyph and colour when the layout
      // changes, so a shape swap reads as the crowd walking rather than as a
      // slideshow.
      transition: 'flow',
      unitValue: 10,
      clusterLabels: {
        show: false,
      },
    },
  },
  legend: {
    position: 'bottom',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// Layout and mark buttons. (pictoState, pictoOptions and pictoWire live in the
// shared head script.)
pictoWire(chart)

Pictogram Crowd in React

Using ApexCharts with React

This Pictogram Crowd example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js
// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/pictograms.js

// Shared by the vanilla-js, React and Vue builds. Layout and mark are two
// INDEPENDENT choices, so the state is two fields and the update payload sets
// each from its own field; nothing here knows which combination is selected.
var pictoState = { layout: 'heart', mark: 'person' }

// The updateOptions payload for the current pair. An empty mark means "no
// glyph", which is just the ordinary dot the chart drew before pictograms
// existed - `shape` carries that, so `pictogram.mark` is left alone.
function pictoOptions() {
  return {
    plotOptions: {
      unit: {
        positions: pictoState.layout,
        shape: pictoState.mark ? 'pictogram' : 'circle',
        pictogram: { mark: pictoState.mark || undefined },
      },
    },
  }
}

function pictoPaint() {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.classList.toggle(
      'on',
      b.getAttribute('data-layout') === pictoState.layout,
    )
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.classList.toggle('on', b.getAttribute('data-mark') === pictoState.mark)
  })
}

// Wire both button rows to a live chart instance. Each format hands over its
// own instance; the behaviour is identical.
function pictoWire(chart) {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.layout = b.getAttribute('data-layout')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.mark = b.getAttribute('data-mark')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  pictoPaint()
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [820, 410, 170],
    options: {
      chart: {
        type: 'unit',
        id: 'pictoCrowd',
        height: 460,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: ['Weekday shifts', 'Weekend shifts', 'On call'],
      colors: ['#1D4E89', '#00A6A0', '#FF8A3D'],
      plotOptions: {
        unit: {
          layout: 'custom',
          positions: 'heart',
          // A glyph, not a dot. `mark` names one of the pictograms; the chart fits
          // it to the box the dot would have occupied, so switching between them
          // never re-flows the layout.
          shape: 'pictogram',
          pictogram: {
            mark: 'person',
          },
          // The same specific volunteer keeps their glyph and colour when the layout
          // changes, so a shape swap reads as the crowd walking rather than as a
          // slideshow.
          transition: 'flow',
          unitValue: 10,
          clusterLabels: {
            show: false,
          },
        },
      },
      legend: {
        position: 'bottom',
      },
    },
  })

  React.useEffect(() => {
    // Reach the live instance by its chart.id, then wire the buttons.
    // updateOptions drives the instance directly, so no React state changes
    // under it.
    const timer = window.setInterval(() => {
      const chart = ApexCharts.getChartByID('pictoCrowd')
      if (!chart) return
      window.clearInterval(timer)
      pictoWire(chart)
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="wrap">
        <h1>1,400 volunteers, one glyph each</h1>
        <p>
          Two independent choices. <b>Layout</b> is where the units go: a heart,
          a house, a plain grid. <b>Mark</b> is what one unit looks like: a dot,
          or a pictogram. They compose, so a crowd of people can be arranged
          into a heart and the same crowd can walk into a house without either
          choice knowing about the other. Pick one of each.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={460}
            />
          </div>
        </div>

        <div className="controls" id="layout-nav">
          <button data-layout="heart" className="on">
            Heart
          </button>
          <button data-layout="human">Person</button>
          <button data-layout="house">House</button>
          <button data-layout="tree">Tree</button>
        </div>
        <div className="controls" id="mark-nav">
          <button data-mark="person" className="on">
            Person
          </button>
          <button data-mark="house">House</button>
          <button data-mark="heart">Heart</button>
          <button data-mark="tree">Tree</button>
          <button data-mark="">Plain dot</button>
        </div>

        <p className="note">
          1 glyph = 10 volunteers. Each glyph is one drawn path, filled in its
          own colour, so the crowd stays this size without a per-icon image or a
          recolour filter.
        </p>
      </div>
    </div>
  )
}

export default ApexChart

Pictogram Crowd in Angular

Using ApexCharts with Angular

This Pictogram Crowd example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private pictoState: any = { layout: 'heart', mark: 'person' };

  private pictoOptions = (): any => {
        return {
          plotOptions: {
            unit: {
              positions: this.pictoState.layout,
              shape: this.pictoState.mark ? 'pictogram' : 'circle',
              pictogram: { mark: this.pictoState.mark || undefined },
            },
          },
        }
      };

  private pictoPaint = (): any => {
        document.querySelectorAll('#layout-nav button').forEach(function (b) {
          b.classList.toggle(
            'on',
            b.getAttribute('data-layout') === this.pictoState.layout,
          )
        })
        document.querySelectorAll('#mark-nav button').forEach(function (b) {
          b.classList.toggle('on', b.getAttribute('data-mark') === this.pictoState.mark)
        })
      };

  private pictoWire = (chart: any): any => {
        document.querySelectorAll('#layout-nav button').forEach(function (b) {
          b.addEventListener('click', function () {
            this.pictoState.layout = b.getAttribute('data-layout')
            chart.updateOptions(this.pictoOptions(), false, true)
            this.pictoPaint()
          })
        })
        document.querySelectorAll('#mark-nav button').forEach(function (b) {
          b.addEventListener('click', function () {
            this.pictoState.mark = b.getAttribute('data-mark')
            chart.updateOptions(this.pictoOptions(), false, true)
            this.pictoPaint()
          })
        })
        this.pictoPaint()
      };

  public chartOptions: Partial<ChartOptions> = {
          series: [820, 410, 170],
          chart: {
            type: 'unit',
            id: 'pictoCrowd',
            height: 460,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: ['Weekday shifts', 'Weekend shifts', 'On call'],
          colors: ['#1D4E89', '#00A6A0', '#FF8A3D'],
          plotOptions: {
            unit: {
              layout: 'custom',
              positions: 'heart',
              // A glyph, not a dot. `mark` names one of the pictograms; the chart fits
              // it to the box the dot would have occupied, so switching between them
              // never re-flows the layout.
              shape: 'pictogram',
              pictogram: {
                mark: 'person',
              },
              // The same specific volunteer keeps their glyph and colour when the layout
              // changes, so a shape swap reads as the crowd walking rather than as a
              // slideshow.
              transition: 'flow',
              unitValue: 10,
              clusterLabels: {
                show: false,
              },
            },
          },
          legend: {
            position: 'bottom',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.pictoWire(this.chart)

    function pictoWire(chart) {
          document.querySelectorAll('#layout-nav button').forEach(function (b) {
            b.addEventListener('click', () => {
              this.pictoState.layout = b.getAttribute('data-layout')
              this.chart.updateOptions(this.pictoOptions(), false, true)
              this.pictoPaint()
            })
          })
          document.querySelectorAll('#mark-nav button').forEach(function (b) {
            b.addEventListener('click', () => {
              this.pictoState.mark = b.getAttribute('data-mark')
              this.chart.updateOptions(this.pictoOptions(), false, true)
              this.pictoPaint()
            })
          })
          this.pictoPaint()
        }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Pictogram Crowd in Vue

Using ApexCharts with Vue

This Pictogram Crowd example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>1,400 volunteers, one glyph each</h1>
      <p>
        Two independent choices. <b>Layout</b> is where the units go: a heart, a
        house, a plain grid. <b>Mark</b> is what one unit looks like: a dot, or
        a pictogram. They compose, so a crowd of people can be arranged into a
        heart and the same crowd can walk into a house without either choice
        knowing about the other. Pick one of each.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="460"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="controls" id="layout-nav">
        <button data-layout="heart" class="on">Heart</button>
        <button data-layout="human">Person</button>
        <button data-layout="house">House</button>
        <button data-layout="tree">Tree</button>
      </div>
      <div class="controls" id="mark-nav">
        <button data-mark="person" class="on">Person</button>
        <button data-mark="house">House</button>
        <button data-mark="heart">Heart</button>
        <button data-mark="tree">Tree</button>
        <button data-mark="">Plain dot</button>
      </div>

      <p class="note">
        1 glyph = 10 volunteers. Each glyph is one drawn path, filled in its own
        colour, so the crowd stays this size without a per-icon image or a
        recolour filter.
      </p>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js
// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/pictograms.js

// Shared by the vanilla-js, React and Vue builds. Layout and mark are two
// INDEPENDENT choices, so the state is two fields and the update payload sets
// each from its own field; nothing here knows which combination is selected.
var pictoState = { layout: 'heart', mark: 'person' }

// The updateOptions payload for the current pair. An empty mark means "no
// glyph", which is just the ordinary dot the chart drew before pictograms
// existed - `shape` carries that, so `pictogram.mark` is left alone.
function pictoOptions() {
  return {
    plotOptions: {
      unit: {
        positions: pictoState.layout,
        shape: pictoState.mark ? 'pictogram' : 'circle',
        pictogram: { mark: pictoState.mark || undefined },
      },
    },
  }
}

function pictoPaint() {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.classList.toggle('on', b.getAttribute('data-layout') === pictoState.layout)
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.classList.toggle('on', b.getAttribute('data-mark') === pictoState.mark)
  })
}

// Wire both button rows to a live chart instance. Each format hands over its
// own instance; the behaviour is identical.
function pictoWire(chart) {
  document.querySelectorAll('#layout-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.layout = b.getAttribute('data-layout')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  document.querySelectorAll('#mark-nav button').forEach(function (b) {
    b.addEventListener('click', function () {
      pictoState.mark = b.getAttribute('data-mark')
      chart.updateOptions(pictoOptions(), false, true)
      pictoPaint()
    })
  })
  pictoPaint()
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [820, 410, 170],
chartOptions: {
chart: {
  type: 'unit',
  id: 'pictoCrowd',
  height: 460,
  animations: {
    enabled: true,
    speed: 900,
  },
},
labels: ['Weekday shifts', 'Weekend shifts', 'On call'],
colors: ['#1D4E89', '#00A6A0', '#FF8A3D'],
plotOptions: {
  unit: {
    layout: 'custom',
    positions: 'heart',
    // A glyph, not a dot. `mark` names one of the pictograms; the chart fits
    // it to the box the dot would have occupied, so switching between them
    // never re-flows the layout.
    shape: 'pictogram',
    pictogram: {
      mark: 'person',
    },
    // The same specific volunteer keeps their glyph and colour when the layout
    // changes, so a shape swap reads as the crowd walking rather than as a
    // slideshow.
    transition: 'flow',
    unitValue: 10,
    clusterLabels: {
      show: false,
    },
  },
},
legend: {
  position: 'bottom',
},
},
pictoTimer: null,
}
},
mounted: function () {
  // Reach the live instance by its chart.id, then wire the buttons.
  // updateOptions drives the instance directly, so no reactive data changes
  // under it.
  var me = this
  me.pictoTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('pictoCrowd')
    if (!chart) return
    window.clearInterval(me.pictoTimer)
    pictoWire(chart)
  }, 50)
},
beforeDestroy: function () {
  window.clearInterval(this.pictoTimer)
},,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 760px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.55;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.controls {
  display: flex;
  gap: 8px;
  flex-wrap: wrap;
  justify-content: center;
  margin: 20px 0 0;
}
button {
  font: inherit;
  font-size: 13px;
  padding: 7px 14px;
  border: 1px solid #d7dee5;
  border-radius: 999px;
  background: #fff;
  color: #2c3e50;
  cursor: pointer;
}
button:hover {
  border-color: #9fb0bd;
}
button.on {
  background: #1d4e89;
  border-color: #1d4e89;
  color: #fff;
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin: 16px 0 0;
}
</style>